'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const ohmyfetch = require('ohmyfetch');
const ufo = require('ufo');

function createApi(url, defaults = {}) {
  const internalTarget = () => {
  };
  const p = (url2) => new Proxy(internalTarget, {
    get(_target, key) {
      const method = key.toUpperCase();
      if (!["GET", "POST", "PUT", "DELETE", "PATCH"].includes(method)) {
        return p(ufo.resolveURL(url2, key));
      }
      const handler = (data, opts = {}) => {
        switch (method) {
          case "GET":
            if (data)
              url2 = ufo.withQuery(url2, data);
            break;
          case "POST":
          case "PUT":
          case "PATCH":
            opts.body = data;
        }
        return ohmyfetch.$fetch(url2, {
          ...defaults,
          ...opts,
          method
        });
      };
      return handler;
    },
    apply(_target, _thisArg, args = []) {
      return p(ufo.resolveURL(url2, ...args.map((i) => `${i}`)));
    }
  });
  return p(url);
}

exports.createApi = createApi;
